git-am.shon commit git-am: take advantage of gettextln and eval_gettextln. (de88c1c)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25C=              pass it through git-apply
  26p=              pass it through git-apply
  27patch-format=   format the patch(es) are in
  28reject          pass it through git-apply
  29resolvemsg=     override error message when patch failure occurs
  30continue        continue applying patches after resolving a conflict
  31r,resolved      synonyms for --continue
  32skip            skip the current patch
  33abort           restore the original branch and abort the patching operation.
  34committer-date-is-author-date    lie about committer date
  35ignore-date     use current timestamp for author date
  36rerere-autoupdate update the index with reused conflict resolution if possible
  37rebasing*       (internal use for git-rebase)"
  38
  39. git-sh-setup
  40. git-sh-i18n
  41prefix=$(git rev-parse --show-prefix)
  42set_reflog_action am
  43require_work_tree
  44cd_to_toplevel
  45
  46git var GIT_COMMITTER_IDENT >/dev/null ||
  47        die "$(gettext "You need to set your committer info first")"
  48
  49if git rev-parse --verify -q HEAD >/dev/null
  50then
  51        HAS_HEAD=yes
  52else
  53        HAS_HEAD=
  54fi
  55
  56cmdline="git am"
  57if test '' != "$interactive"
  58then
  59        cmdline="$cmdline -i"
  60fi
  61if test '' != "$threeway"
  62then
  63        cmdline="$cmdline -3"
  64fi
  65
  66sq () {
  67        git rev-parse --sq-quote "$@"
  68}
  69
  70stop_here () {
  71    echo "$1" >"$dotest/next"
  72    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  73    exit 1
  74}
  75
  76safe_to_abort () {
  77        if test -f "$dotest/dirtyindex"
  78        then
  79                return 1
  80        fi
  81
  82        if ! test -s "$dotest/abort-safety"
  83        then
  84                return 0
  85        fi
  86
  87        abort_safety=$(cat "$dotest/abort-safety")
  88        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  89        then
  90                return 0
  91        fi
  92                gettextln "You seem to have moved HEAD since the last 'am' failure.
  93Not rewinding to ORIG_HEAD" >&2
  94        return 1
  95}
  96
  97stop_here_user_resolve () {
  98    if [ -n "$resolvemsg" ]; then
  99            printf '%s\n' "$resolvemsg"
 100            stop_here $1
 101    fi
 102    eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
 103If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 104To restore the original branch and stop patching run \"\$cmdline --abort\"."
 105
 106    stop_here $1
 107}
 108
 109go_next () {
 110        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 111                "$dotest/patch" "$dotest/info"
 112        echo "$next" >"$dotest/next"
 113        this=$next
 114}
 115
 116cannot_fallback () {
 117        echo "$1"
 118        gettextln "Cannot fall back to three-way merge."
 119        exit 1
 120}
 121
 122fall_back_3way () {
 123    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 124
 125    rm -fr "$dotest"/patch-merge-*
 126    mkdir "$dotest/patch-merge-tmp-dir"
 127
 128    # First see if the patch records the index info that we can use.
 129    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 130        "$dotest/patch" &&
 131    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 132    git write-tree >"$dotest/patch-merge-base+" ||
 133    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 134
 135    say Using index info to reconstruct a base tree...
 136    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 137        git apply --cached <"$dotest/patch"
 138    then
 139        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 140        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 141    else
 142        cannot_fallback "$(gettext "Did you hand edit your patch?
 143It does not apply to blobs recorded in its index.")"
 144    fi
 145
 146    test -f "$dotest/patch-merge-index" &&
 147    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 148    orig_tree=$(cat "$dotest/patch-merge-base") &&
 149    rm -fr "$dotest"/patch-merge-* || exit 1
 150
 151    say "$(gettext "Falling back to patching base and 3-way merge...")"
 152
 153    # This is not so wrong.  Depending on which base we picked,
 154    # orig_tree may be wildly different from ours, but his_tree
 155    # has the same set of wildly different changes in parts the
 156    # patch did not touch, so recursive ends up canceling them,
 157    # saying that we reverted all those changes.
 158
 159    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 160    export GITHEAD_$his_tree
 161    if test -n "$GIT_QUIET"
 162    then
 163            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 164    fi
 165    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 166            git rerere $allow_rerere_autoupdate
 167            echo Failed to merge in the changes.
 168            exit 1
 169    }
 170    unset GITHEAD_$his_tree
 171}
 172
 173clean_abort () {
 174        test $# = 0 || echo >&2 "$@"
 175        rm -fr "$dotest"
 176        exit 1
 177}
 178
 179patch_format=
 180
 181check_patch_format () {
 182        # early return if patch_format was set from the command line
 183        if test -n "$patch_format"
 184        then
 185                return 0
 186        fi
 187
 188        # we default to mbox format if input is from stdin and for
 189        # directories
 190        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 191        then
 192                patch_format=mbox
 193                return 0
 194        fi
 195
 196        # otherwise, check the first few lines of the first patch to try
 197        # to detect its format
 198        {
 199                read l1
 200                read l2
 201                read l3
 202                case "$l1" in
 203                "From "* | "From: "*)
 204                        patch_format=mbox
 205                        ;;
 206                '# This series applies on GIT commit'*)
 207                        patch_format=stgit-series
 208                        ;;
 209                "# HG changeset patch")
 210                        patch_format=hg
 211                        ;;
 212                *)
 213                        # if the second line is empty and the third is
 214                        # a From, Author or Date entry, this is very
 215                        # likely an StGIT patch
 216                        case "$l2,$l3" in
 217                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 218                                patch_format=stgit
 219                                ;;
 220                        *)
 221                                ;;
 222                        esac
 223                        ;;
 224                esac
 225                if test -z "$patch_format" &&
 226                        test -n "$l1" &&
 227                        test -n "$l2" &&
 228                        test -n "$l3"
 229                then
 230                        # This begins with three non-empty lines.  Is this a
 231                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 232                        # discarding the indented remainder of folded lines,
 233                        # and see if it looks like that they all begin with the
 234                        # header field names...
 235                        tr -d '\015' <"$1" |
 236                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 237                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 238                        patch_format=mbox
 239                fi
 240        } < "$1" || clean_abort
 241}
 242
 243split_patches () {
 244        case "$patch_format" in
 245        mbox)
 246                if test -n "$rebasing" || test t = "$keepcr"
 247                then
 248                    keep_cr=--keep-cr
 249                else
 250                    keep_cr=
 251                fi
 252                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 253                clean_abort
 254                ;;
 255        stgit-series)
 256                if test $# -ne 1
 257                then
 258                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 259                fi
 260                series_dir=`dirname "$1"`
 261                series_file="$1"
 262                shift
 263                {
 264                        set x
 265                        while read filename
 266                        do
 267                                set "$@" "$series_dir/$filename"
 268                        done
 269                        # remove the safety x
 270                        shift
 271                        # remove the arg coming from the first-line comment
 272                        shift
 273                } < "$series_file" || clean_abort
 274                # set the patch format appropriately
 275                patch_format=stgit
 276                # now handle the actual StGIT patches
 277                split_patches "$@"
 278                ;;
 279        stgit)
 280                this=0
 281                for stgit in "$@"
 282                do
 283                        this=`expr "$this" + 1`
 284                        msgnum=`printf "%0${prec}d" $this`
 285                        # Perl version of StGIT parse_patch. The first nonemptyline
 286                        # not starting with Author, From or Date is the
 287                        # subject, and the body starts with the next nonempty
 288                        # line not starting with Author, From or Date
 289                        perl -ne 'BEGIN { $subject = 0 }
 290                                if ($subject > 1) { print ; }
 291                                elsif (/^\s+$/) { next ; }
 292                                elsif (/^Author:/) { print s/Author/From/ ; }
 293                                elsif (/^(From|Date)/) { print ; }
 294                                elsif ($subject) {
 295                                        $subject = 2 ;
 296                                        print "\n" ;
 297                                        print ;
 298                                } else {
 299                                        print "Subject: ", $_ ;
 300                                        $subject = 1;
 301                                }
 302                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 303                done
 304                echo "$this" > "$dotest/last"
 305                this=
 306                msgnum=
 307                ;;
 308        *)
 309                if test -n "$parse_patch" ; then
 310                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 311                else
 312                        clean_abort "$(gettext "Patch format detection failed.")"
 313                fi
 314                ;;
 315        esac
 316}
 317
 318prec=4
 319dotest="$GIT_DIR/rebase-apply"
 320sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 321resolvemsg= resume= scissors= no_inbody_headers=
 322git_apply_opt=
 323committer_date_is_author_date=
 324ignore_date=
 325allow_rerere_autoupdate=
 326
 327if test "$(git config --bool --get am.keepcr)" = true
 328then
 329    keepcr=t
 330fi
 331
 332while test $# != 0
 333do
 334        case "$1" in
 335        -i|--interactive)
 336                interactive=t ;;
 337        -b|--binary)
 338                : ;;
 339        -3|--3way)
 340                threeway=t ;;
 341        -s|--signoff)
 342                sign=t ;;
 343        -u|--utf8)
 344                utf8=t ;; # this is now default
 345        --no-utf8)
 346                utf8= ;;
 347        -k|--keep)
 348                keep=t ;;
 349        -c|--scissors)
 350                scissors=t ;;
 351        --no-scissors)
 352                scissors=f ;;
 353        -r|--resolved|--continue)
 354                resolved=t ;;
 355        --skip)
 356                skip=t ;;
 357        --abort)
 358                abort=t ;;
 359        --rebasing)
 360                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 361        -d|--dotest)
 362                die "$(gettext "-d option is no longer supported.  Do not use.")"
 363                ;;
 364        --resolvemsg)
 365                shift; resolvemsg=$1 ;;
 366        --whitespace|--directory)
 367                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 368        -C|-p)
 369                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 370        --patch-format)
 371                shift ; patch_format="$1" ;;
 372        --reject|--ignore-whitespace|--ignore-space-change)
 373                git_apply_opt="$git_apply_opt $1" ;;
 374        --committer-date-is-author-date)
 375                committer_date_is_author_date=t ;;
 376        --ignore-date)
 377                ignore_date=t ;;
 378        --rerere-autoupdate|--no-rerere-autoupdate)
 379                allow_rerere_autoupdate="$1" ;;
 380        -q|--quiet)
 381                GIT_QUIET=t ;;
 382        --keep-cr)
 383                keepcr=t ;;
 384        --no-keep-cr)
 385                keepcr=f ;;
 386        --)
 387                shift; break ;;
 388        *)
 389                usage ;;
 390        esac
 391        shift
 392done
 393
 394# If the dotest directory exists, but we have finished applying all the
 395# patches in them, clear it out.
 396if test -d "$dotest" &&
 397   last=$(cat "$dotest/last") &&
 398   next=$(cat "$dotest/next") &&
 399   test $# != 0 &&
 400   test "$next" -gt "$last"
 401then
 402   rm -fr "$dotest"
 403fi
 404
 405if test -d "$dotest"
 406then
 407        case "$#,$skip$resolved$abort" in
 408        0,*t*)
 409                # Explicit resume command and we do not have file, so
 410                # we are happy.
 411                : ;;
 412        0,)
 413                # No file input but without resume parameters; catch
 414                # user error to feed us a patch from standard input
 415                # when there is already $dotest.  This is somewhat
 416                # unreliable -- stdin could be /dev/null for example
 417                # and the caller did not intend to feed us a patch but
 418                # wanted to continue unattended.
 419                test -t 0
 420                ;;
 421        *)
 422                false
 423                ;;
 424        esac ||
 425        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 426        resume=yes
 427
 428        case "$skip,$abort" in
 429        t,t)
 430                die "$(gettext "Please make up your mind. --skip or --abort?")"
 431                ;;
 432        t,)
 433                git rerere clear
 434                git read-tree --reset -u HEAD HEAD
 435                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 436                git reset HEAD
 437                git update-ref ORIG_HEAD $orig_head
 438                ;;
 439        ,t)
 440                if test -f "$dotest/rebasing"
 441                then
 442                        exec git rebase --abort
 443                fi
 444                git rerere clear
 445                if safe_to_abort
 446                then
 447                        git read-tree --reset -u HEAD ORIG_HEAD
 448                        git reset ORIG_HEAD
 449                fi
 450                rm -fr "$dotest"
 451                exit ;;
 452        esac
 453        rm -f "$dotest/dirtyindex"
 454else
 455        # Make sure we are not given --skip, --resolved, nor --abort
 456        test "$skip$resolved$abort" = "" ||
 457                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 458
 459        # Start afresh.
 460        mkdir -p "$dotest" || exit
 461
 462        if test -n "$prefix" && test $# != 0
 463        then
 464                first=t
 465                for arg
 466                do
 467                        test -n "$first" && {
 468                                set x
 469                                first=
 470                        }
 471                        if is_absolute_path "$arg"
 472                        then
 473                                set "$@" "$arg"
 474                        else
 475                                set "$@" "$prefix$arg"
 476                        fi
 477                done
 478                shift
 479        fi
 480
 481        check_patch_format "$@"
 482
 483        split_patches "$@"
 484
 485        # -i can and must be given when resuming; everything
 486        # else is kept
 487        echo " $git_apply_opt" >"$dotest/apply-opt"
 488        echo "$threeway" >"$dotest/threeway"
 489        echo "$sign" >"$dotest/sign"
 490        echo "$utf8" >"$dotest/utf8"
 491        echo "$keep" >"$dotest/keep"
 492        echo "$keepcr" >"$dotest/keepcr"
 493        echo "$scissors" >"$dotest/scissors"
 494        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 495        echo "$GIT_QUIET" >"$dotest/quiet"
 496        echo 1 >"$dotest/next"
 497        if test -n "$rebasing"
 498        then
 499                : >"$dotest/rebasing"
 500        else
 501                : >"$dotest/applying"
 502                if test -n "$HAS_HEAD"
 503                then
 504                        git update-ref ORIG_HEAD HEAD
 505                else
 506                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 507                fi
 508        fi
 509fi
 510
 511case "$resolved" in
 512'')
 513        case "$HAS_HEAD" in
 514        '')
 515                files=$(git ls-files) ;;
 516        ?*)
 517                files=$(git diff-index --cached --name-only HEAD --) ;;
 518        esac || exit
 519        if test "$files"
 520        then
 521                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 522                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 523        fi
 524esac
 525
 526if test "$(cat "$dotest/utf8")" = t
 527then
 528        utf8=-u
 529else
 530        utf8=-n
 531fi
 532if test "$(cat "$dotest/keep")" = t
 533then
 534        keep=-k
 535fi
 536case "$(cat "$dotest/keepcr")" in
 537t)
 538        keepcr=--keep-cr ;;
 539f)
 540        keepcr=--no-keep-cr ;;
 541esac
 542case "$(cat "$dotest/scissors")" in
 543t)
 544        scissors=--scissors ;;
 545f)
 546        scissors=--no-scissors ;;
 547esac
 548if test "$(cat "$dotest/no_inbody_headers")" = t
 549then
 550        no_inbody_headers=--no-inbody-headers
 551else
 552        no_inbody_headers=
 553fi
 554if test "$(cat "$dotest/quiet")" = t
 555then
 556        GIT_QUIET=t
 557fi
 558if test "$(cat "$dotest/threeway")" = t
 559then
 560        threeway=t
 561fi
 562git_apply_opt=$(cat "$dotest/apply-opt")
 563if test "$(cat "$dotest/sign")" = t
 564then
 565        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 566                        s/>.*/>/
 567                        s/^/Signed-off-by: /'
 568                `
 569else
 570        SIGNOFF=
 571fi
 572
 573last=`cat "$dotest/last"`
 574this=`cat "$dotest/next"`
 575if test "$skip" = t
 576then
 577        this=`expr "$this" + 1`
 578        resume=
 579fi
 580
 581while test "$this" -le "$last"
 582do
 583        msgnum=`printf "%0${prec}d" $this`
 584        next=`expr "$this" + 1`
 585        test -f "$dotest/$msgnum" || {
 586                resume=
 587                go_next
 588                continue
 589        }
 590
 591        # If we are not resuming, parse and extract the patch information
 592        # into separate files:
 593        #  - info records the authorship and title
 594        #  - msg is the rest of commit log message
 595        #  - patch is the patch body.
 596        #
 597        # When we are resuming, these files are either already prepared
 598        # by the user, or the user can tell us to do so by --resolved flag.
 599        case "$resume" in
 600        '')
 601                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 602                        <"$dotest/$msgnum" >"$dotest/info" ||
 603                        stop_here $this
 604
 605                # skip pine's internal folder data
 606                sane_grep '^Author: Mail System Internal Data$' \
 607                        <"$dotest"/info >/dev/null &&
 608                        go_next && continue
 609
 610                test -s "$dotest/patch" || {
 611                        eval_gettextln "Patch is empty.  Was it split wrong?
 612If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 613To restore the original branch and stop patching run \"\$cmdline --abort\"."
 614                        stop_here $this
 615                }
 616                rm -f "$dotest/original-commit" "$dotest/author-script"
 617                if test -f "$dotest/rebasing" &&
 618                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 619                                -e q "$dotest/$msgnum") &&
 620                        test "$(git cat-file -t "$commit")" = commit
 621                then
 622                        git cat-file commit "$commit" |
 623                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 624                        echo "$commit" > "$dotest/original-commit"
 625                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 626                else
 627                        {
 628                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 629                                echo
 630                                cat "$dotest/msg"
 631                        } |
 632                        git stripspace > "$dotest/msg-clean"
 633                fi
 634                ;;
 635        esac
 636
 637        if test -f "$dotest/author-script"
 638        then
 639                eval $(cat "$dotest/author-script")
 640        else
 641                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 642                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 643                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 644        fi
 645
 646        if test -z "$GIT_AUTHOR_EMAIL"
 647        then
 648                gettextln "Patch does not have a valid e-mail address."
 649                stop_here $this
 650        fi
 651
 652        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 653
 654        case "$resume" in
 655        '')
 656            if test '' != "$SIGNOFF"
 657            then
 658                LAST_SIGNED_OFF_BY=`
 659                    sed -ne '/^Signed-off-by: /p' \
 660                    "$dotest/msg-clean" |
 661                    sed -ne '$p'
 662                `
 663                ADD_SIGNOFF=`
 664                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 665                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 666                    echo "$SIGNOFF"
 667                }`
 668            else
 669                ADD_SIGNOFF=
 670            fi
 671            {
 672                if test -s "$dotest/msg-clean"
 673                then
 674                        cat "$dotest/msg-clean"
 675                fi
 676                if test '' != "$ADD_SIGNOFF"
 677                then
 678                        echo "$ADD_SIGNOFF"
 679                fi
 680            } >"$dotest/final-commit"
 681            ;;
 682        *)
 683                case "$resolved$interactive" in
 684                tt)
 685                        # This is used only for interactive view option.
 686                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 687                        ;;
 688                esac
 689        esac
 690
 691        resume=
 692        if test "$interactive" = t
 693        then
 694            test -t 0 ||
 695            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 696            action=again
 697            while test "$action" = again
 698            do
 699                gettextln "Commit Body is:"
 700                echo "--------------------------"
 701                cat "$dotest/final-commit"
 702                echo "--------------------------"
 703                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 704                # in your translation. The program will only accept English
 705                # input at this point.
 706                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 707                read reply
 708                case "$reply" in
 709                [yY]*) action=yes ;;
 710                [aA]*) action=yes interactive= ;;
 711                [nN]*) action=skip ;;
 712                [eE]*) git_editor "$dotest/final-commit"
 713                       action=again ;;
 714                [vV]*) action=again
 715                       git_pager "$dotest/patch" ;;
 716                *)     action=again ;;
 717                esac
 718            done
 719        else
 720            action=yes
 721        fi
 722
 723        if test -f "$dotest/final-commit"
 724        then
 725                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 726        else
 727                FIRSTLINE=""
 728        fi
 729
 730        if test $action = skip
 731        then
 732                go_next
 733                continue
 734        fi
 735
 736        if test -x "$GIT_DIR"/hooks/applypatch-msg
 737        then
 738                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 739                stop_here $this
 740        fi
 741
 742        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 743
 744        case "$resolved" in
 745        '')
 746                # When we are allowed to fall back to 3-way later, don't give
 747                # false errors during the initial attempt.
 748                squelch=
 749                if test "$threeway" = t
 750                then
 751                        squelch='>/dev/null 2>&1 '
 752                fi
 753                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 754                apply_status=$?
 755                ;;
 756        t)
 757                # Resolved means the user did all the hard work, and
 758                # we do not have to do any patch application.  Just
 759                # trust what the user has in the index file and the
 760                # working tree.
 761                resolved=
 762                git diff-index --quiet --cached HEAD -- && {
 763                        gettextln "No changes - did you forget to use 'git add'?
 764If there is nothing left to stage, chances are that something else
 765already introduced the same changes; you might want to skip this patch."
 766                        stop_here_user_resolve $this
 767                }
 768                unmerged=$(git ls-files -u)
 769                if test -n "$unmerged"
 770                then
 771                        gettextln "You still have unmerged paths in your index
 772did you forget to use 'git add'?"
 773                        stop_here_user_resolve $this
 774                fi
 775                apply_status=0
 776                git rerere
 777                ;;
 778        esac
 779
 780        if test $apply_status != 0 && test "$threeway" = t
 781        then
 782                if (fall_back_3way)
 783                then
 784                    # Applying the patch to an earlier tree and merging the
 785                    # result may have produced the same tree as ours.
 786                    git diff-index --quiet --cached HEAD -- && {
 787                        say "$(gettext "No changes -- Patch already applied.")"
 788                        go_next
 789                        continue
 790                    }
 791                    # clear apply_status -- we have successfully merged.
 792                    apply_status=0
 793                fi
 794        fi
 795        if test $apply_status != 0
 796        then
 797                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 798                stop_here_user_resolve $this
 799        fi
 800
 801        if test -x "$GIT_DIR"/hooks/pre-applypatch
 802        then
 803                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 804        fi
 805
 806        tree=$(git write-tree) &&
 807        commit=$(
 808                if test -n "$ignore_date"
 809                then
 810                        GIT_AUTHOR_DATE=
 811                fi
 812                parent=$(git rev-parse --verify -q HEAD) ||
 813                say >&2 "$(gettext "applying to an empty history")"
 814
 815                if test -n "$committer_date_is_author_date"
 816                then
 817                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 818                        export GIT_COMMITTER_DATE
 819                fi &&
 820                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 821        ) &&
 822        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 823        stop_here $this
 824
 825        if test -f "$dotest/original-commit"; then
 826                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 827        fi
 828
 829        if test -x "$GIT_DIR"/hooks/post-applypatch
 830        then
 831                "$GIT_DIR"/hooks/post-applypatch
 832        fi
 833
 834        go_next
 835done
 836
 837if test -s "$dotest"/rewritten; then
 838    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 839    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 840        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 841    fi
 842fi
 843
 844rm -fr "$dotest"
 845git gc --auto